/*pb6   mopwm0
 * pb4    m0pwm2
 *
 *ԴǿģƵ1900-4000HZ 
 *
*/
/*
#include <stdint.h>
#include <stdbool.h>
#include "inc/tm4c123gh6pm.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "driverlib/sysctl.h"
#include "driverlib/rom.h"
#include "driverlib/gpio.h"
#include "driverlib/pwm.h"
#include "driverlib/fpu.h"
#include "driverlib/pin_map.h"
#include "driverlib/timer.h"
#include "driverlib/interrupt.h"
#include "driverlib/fpu.h"
#include "driverlib/uart.h"
#include "utils/uartstdio.h"*/

#include <stdint.h>
#include <stdbool.h>
#include "inc/tm4c123gh6pm.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "driverlib/debug.h"
#include "driverlib/fpu.h"
#include "driverlib/gpio.h"
#include "driverlib/interrupt.h"
#include "driverlib/pin_map.h"
#include "driverlib/rom.h"
#include "driverlib/sysctl.h"
#include "driverlib/uart.h"
#include "driverlib/pwm.h"
#include "driverlib/timer.h"
#include "utils/uartstdio.h"

float TimerStart ;
float TimerFinal ;
float TimerInterval ;
float Distance;

uint32_t ui32Counter = 0;
static bool g_bIntFlag = false;

void
InitConsole(void) //for uart0
{
    //
    // Enable GPIO port A which is used for UART0 pins.
    // TODO: change this to whichever GPIO port you are using.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);

    //
    // Configure the pin muxing for UART0 functions on port A0 and A1.
    // This step is not necessary if your part does not support pin muxing.
    // TODO: change this to select the port/pin you are using.
    //
    GPIOPinConfigure(GPIO_PA0_U0RX);
    GPIOPinConfigure(GPIO_PA1_U0TX);

    //
    // Enable UART0 so that we can configure the clock.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);

    //
    // Use the internal 16MHz oscillator as the UART clock source.
    //
    UARTClockSourceSet(UART0_BASE, UART_CLOCK_PIOSC);

    //
    // Select the alternate (UART) function for these pins.
    // TODO: change this to select the port/pin you are using.
    //
    GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);

    //
    // Initialize the UART for console I/O.
    //
    UARTStdioConfig(0, 115200, 16000000);
}


void f_char_printf(float Xangle)
{
float temp = Xangle;

if(Xangle>=0){
UARTprintf("%d.%d",(int32_t)temp ,(int32_t)((temp -(int32_t)temp )*1000));

}

else{

temp = 0-temp;

UARTprintf("-%d.%d",(int32_t)temp ,(int32_t)((temp -(int32_t)temp )*1000));

}

}
/*void ultrasonic(void)
{

	//TimerEnable(TIMER1_BASE, TIMER_A);
	PWMOutputState(PWM0_BASE, PWM_OUT_0_BIT, true);

	//SysCtlDelay((SysCtlClockGet() * 12) / 15);

	TimerLoadSet(TIMER1_BASE,TIMER_A,0);
	//TimerEnable(TIMER1_BASE, TIMER_A);

	//TimerStart = TimerValueGet(TIMER1_BASE,TIMER_A);
	while(ui32Counter < 1)
	{
	    ui32Counter++;
	}
	ui32Counter = 0;

	//TimerStart = TimerValueGet(TIMER1_BASE,TIMER_A);
	PWMOutputState(PWM0_BASE, PWM_OUT_0_BIT, false);
}*/


int main (void)
 {
	SysCtlClockSet(SYSCTL_SYSDIV_5|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|SYSCTL_OSC_MAIN); //ϵͳʱ40MHZ

	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER1);//ʹTIMER1 32λ(TIMER0A16λ+TIMER0B16λ)
	SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM0);//ʹPWM0ģ
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);  //ʹGPIOB


	InitConsole();//UART޹
	UARTprintf("******************************************* \n");

	GPIOPinTypePWM(GPIO_PORTB_BASE, GPIO_PIN_6);//PB6ΪPWM

	GPIOPinConfigure(GPIO_PB6_M0PWM0);    //PB6ΪPWM

	SysCtlPWMClockSet(SYSCTL_PWMDIV_1);//PWMʱ

	PWMGenConfigure(PWM0_BASE,PWM_GEN_0,PWM_GEN_MODE_UP_DOWN| PWM_GEN_MODE_NO_SYNC);//PWM0Ӽͬ

	PWMGenPeriodSet(PWM0_BASE, PWM_GEN_0, 1000);//PWMƵ40KHz

	PWMPulseWidthSet(PWM0_BASE, PWM_OUT_0, 500);//PWM0/PWM1ȣ50%ռձ

	PWMGenEnable(PWM0_BASE, PWM_GEN_0);//ʹPWM


	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_4);//PB4Ϊܽ

	GPIOPinConfigure(GPIO_PB4_T1CCP0);    //Timer

	GPIOPinTypeTimer(GPIO_PORTB_BASE, GPIO_PIN_4);//PB4ΪTimer

	TimerConfigure(TIMER1_BASE,TIMER_CFG_A_CAP_TIME_UP|TIMER_CFG_SPLIT_PAIR);//ʱģʽز

	TimerControlEvent(TIMER1_BASE,TIMER_A,TIMER_EVENT_POS_EDGE);    //ģʽAʱز

	IntEnable(INT_TIMER1A);  //ʹTIMER0A

	TimerIntEnable(TIMER1_BASE, TIMER_CAPA_EVENT);   //ʱA¼ж


	IntMasterEnable();//master interrupt enable API for all interrupts

	TimerEnable(TIMER1_BASE, TIMER_A);//TimerEnable(TIMER1_BASE, TIMER_A);

	PWMOutputState(PWM0_BASE, PWM_OUT_0_BIT, true);

	while(ui32Counter < 3)
	{
	    ui32Counter++;
	}
	ui32Counter = 0;

	PWMOutputState(PWM0_BASE, PWM_OUT_0_BIT, false);
	SysCtlDelay(7);

	while(1)
	{

    }
 }
void Timer1IntHandler()
{


	TimerFinal = TimerValueGet(TIMER1_BASE,TIMER_A);//TimerʼʱʱΪʱ䣬жʱΪյʱ䣬

	Distance = (TimerFinal/SysCtlClockGet())*17000.0 ;//

	f_char_printf(Distance);

	UARTprintf(". . .over \n");
	TimerIntClear(TIMER1_BASE,TIMER_CAPA_EVENT);//жϱ־
}
